/*eslint-disable block-scoped-var, id-length, no-control-regex, no-magic-numbers, no-prototype-builtins, no-redeclare, no-shadow, no-var, sort-vars*/
"use strict";

var $protobuf = require("protobufjs/minimal");

// Common aliases
var $Reader = $protobuf.Reader, $Writer = $protobuf.Writer, $util = $protobuf.util;

// Exported root namespace
var $root = $protobuf.roots["default"] || ($protobuf.roots["default"] = {});

$root.Update = (function() {

    /**
     * Properties of an Update.
     * @exports IUpdate
     * @interface IUpdate
     * @property {IPreviewData|null} [previewData] Update previewData
     * @property {ICanvasData|null} [canvasData] Update canvasData
     */

    /**
     * Constructs a new Update.
     * @exports Update
     * @classdesc Represents an Update.
     * @implements IUpdate
     * @constructor
     * @param {IUpdate=} [properties] Properties to set
     */
    function Update(properties) {
        if (properties)
            for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                if (properties[keys[i]] != null)
                    this[keys[i]] = properties[keys[i]];
    }

    /**
     * Update previewData.
     * @member {IPreviewData|null|undefined} previewData
     * @memberof Update
     * @instance
     */
    Update.prototype.previewData = null;

    /**
     * Update canvasData.
     * @member {ICanvasData|null|undefined} canvasData
     * @memberof Update
     * @instance
     */
    Update.prototype.canvasData = null;

    /**
     * Creates a new Update instance using the specified properties.
     * @function create
     * @memberof Update
     * @static
     * @param {IUpdate=} [properties] Properties to set
     * @returns {Update} Update instance
     */
    Update.create = function create(properties) {
        return new Update(properties);
    };

    /**
     * Encodes the specified Update message. Does not implicitly {@link Update.verify|verify} messages.
     * @function encode
     * @memberof Update
     * @static
     * @param {IUpdate} message Update message or plain object to encode
     * @param {$protobuf.Writer} [writer] Writer to encode to
     * @returns {$protobuf.Writer} Writer
     */
    Update.encode = function encode(message, writer) {
        if (!writer)
            writer = $Writer.create();
        if (message.previewData != null && message.hasOwnProperty("previewData"))
            $root.PreviewData.encode(message.previewData, writer.uint32(/* id 0, wireType 2 =*/2).fork()).ldelim();
        if (message.canvasData != null && message.hasOwnProperty("canvasData"))
            $root.CanvasData.encode(message.canvasData, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
        return writer;
    };

    /**
     * Encodes the specified Update message, length delimited. Does not implicitly {@link Update.verify|verify} messages.
     * @function encodeDelimited
     * @memberof Update
     * @static
     * @param {IUpdate} message Update message or plain object to encode
     * @param {$protobuf.Writer} [writer] Writer to encode to
     * @returns {$protobuf.Writer} Writer
     */
    Update.encodeDelimited = function encodeDelimited(message, writer) {
        return this.encode(message, writer).ldelim();
    };

    /**
     * Decodes an Update message from the specified reader or buffer.
     * @function decode
     * @memberof Update
     * @static
     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
     * @param {number} [length] Message length if known beforehand
     * @returns {Update} Update
     * @throws {Error} If the payload is not a reader or valid buffer
     * @throws {$protobuf.util.ProtocolError} If required fields are missing
     */
    Update.decode = function decode(reader, length) {
        if (!(reader instanceof $Reader))
            reader = $Reader.create(reader);
        var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Update();
        while (reader.pos < end) {
            var tag = reader.uint32();
            switch (tag >>> 3) {
            case 0:
                message.previewData = $root.PreviewData.decode(reader, reader.uint32());
                break;
            case 1:
                message.canvasData = $root.CanvasData.decode(reader, reader.uint32());
                break;
            default:
                reader.skipType(tag & 7);
                break;
            }
        }
        return message;
    };

    /**
     * Decodes an Update message from the specified reader or buffer, length delimited.
     * @function decodeDelimited
     * @memberof Update
     * @static
     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
     * @returns {Update} Update
     * @throws {Error} If the payload is not a reader or valid buffer
     * @throws {$protobuf.util.ProtocolError} If required fields are missing
     */
    Update.decodeDelimited = function decodeDelimited(reader) {
        if (!(reader instanceof $Reader))
            reader = new $Reader(reader);
        return this.decode(reader, reader.uint32());
    };

    /**
     * Verifies an Update message.
     * @function verify
     * @memberof Update
     * @static
     * @param {Object.<string,*>} message Plain object to verify
     * @returns {string|null} `null` if valid, otherwise the reason why it is not
     */
    Update.verify = function verify(message) {
        if (typeof message !== "object" || message === null)
            return "object expected";
        if (message.previewData != null && message.hasOwnProperty("previewData")) {
            var error = $root.PreviewData.verify(message.previewData);
            if (error)
                return "previewData." + error;
        }
        if (message.canvasData != null && message.hasOwnProperty("canvasData")) {
            var error = $root.CanvasData.verify(message.canvasData);
            if (error)
                return "canvasData." + error;
        }
        return null;
    };

    /**
     * Creates an Update message from a plain object. Also converts values to their respective internal types.
     * @function fromObject
     * @memberof Update
     * @static
     * @param {Object.<string,*>} object Plain object
     * @returns {Update} Update
     */
    Update.fromObject = function fromObject(object) {
        if (object instanceof $root.Update)
            return object;
        var message = new $root.Update();
        if (object.previewData != null) {
            if (typeof object.previewData !== "object")
                throw TypeError(".Update.previewData: object expected");
            message.previewData = $root.PreviewData.fromObject(object.previewData);
        }
        if (object.canvasData != null) {
            if (typeof object.canvasData !== "object")
                throw TypeError(".Update.canvasData: object expected");
            message.canvasData = $root.CanvasData.fromObject(object.canvasData);
        }
        return message;
    };

    /**
     * Creates a plain object from an Update message. Also converts values to other types if specified.
     * @function toObject
     * @memberof Update
     * @static
     * @param {Update} message Update
     * @param {$protobuf.IConversionOptions} [options] Conversion options
     * @returns {Object.<string,*>} Plain object
     */
    Update.toObject = function toObject(message, options) {
        if (!options)
            options = {};
        var object = {};
        if (options.defaults) {
            object.previewData = null;
            object.canvasData = null;
        }
        if (message.previewData != null && message.hasOwnProperty("previewData"))
            object.previewData = $root.PreviewData.toObject(message.previewData, options);
        if (message.canvasData != null && message.hasOwnProperty("canvasData"))
            object.canvasData = $root.CanvasData.toObject(message.canvasData, options);
        return object;
    };

    /**
     * Converts this Update to JSON.
     * @function toJSON
     * @memberof Update
     * @instance
     * @returns {Object.<string,*>} JSON object
     */
    Update.prototype.toJSON = function toJSON() {
        return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
    };

    return Update;
})();

$root.PreviewData = (function() {

    /**
     * Properties of a PreviewData.
     * @exports IPreviewData
     * @interface IPreviewData
     * @property {string} json PreviewData json
     */

    /**
     * Constructs a new PreviewData.
     * @exports PreviewData
     * @classdesc Represents a PreviewData.
     * @implements IPreviewData
     * @constructor
     * @param {IPreviewData=} [properties] Properties to set
     */
    function PreviewData(properties) {
        if (properties)
            for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                if (properties[keys[i]] != null)
                    this[keys[i]] = properties[keys[i]];
    }

    /**
     * PreviewData json.
     * @member {string} json
     * @memberof PreviewData
     * @instance
     */
    PreviewData.prototype.json = "";

    /**
     * Creates a new PreviewData instance using the specified properties.
     * @function create
     * @memberof PreviewData
     * @static
     * @param {IPreviewData=} [properties] Properties to set
     * @returns {PreviewData} PreviewData instance
     */
    PreviewData.create = function create(properties) {
        return new PreviewData(properties);
    };

    /**
     * Encodes the specified PreviewData message. Does not implicitly {@link PreviewData.verify|verify} messages.
     * @function encode
     * @memberof PreviewData
     * @static
     * @param {IPreviewData} message PreviewData message or plain object to encode
     * @param {$protobuf.Writer} [writer] Writer to encode to
     * @returns {$protobuf.Writer} Writer
     */
    PreviewData.encode = function encode(message, writer) {
        if (!writer)
            writer = $Writer.create();
        writer.uint32(/* id 10, wireType 2 =*/82).string(message.json);
        return writer;
    };

    /**
     * Encodes the specified PreviewData message, length delimited. Does not implicitly {@link PreviewData.verify|verify} messages.
     * @function encodeDelimited
     * @memberof PreviewData
     * @static
     * @param {IPreviewData} message PreviewData message or plain object to encode
     * @param {$protobuf.Writer} [writer] Writer to encode to
     * @returns {$protobuf.Writer} Writer
     */
    PreviewData.encodeDelimited = function encodeDelimited(message, writer) {
        return this.encode(message, writer).ldelim();
    };

    /**
     * Decodes a PreviewData message from the specified reader or buffer.
     * @function decode
     * @memberof PreviewData
     * @static
     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
     * @param {number} [length] Message length if known beforehand
     * @returns {PreviewData} PreviewData
     * @throws {Error} If the payload is not a reader or valid buffer
     * @throws {$protobuf.util.ProtocolError} If required fields are missing
     */
    PreviewData.decode = function decode(reader, length) {
        if (!(reader instanceof $Reader))
            reader = $Reader.create(reader);
        var end = length === undefined ? reader.len : reader.pos + length, message = new $root.PreviewData();
        while (reader.pos < end) {
            var tag = reader.uint32();
            switch (tag >>> 3) {
            case 10:
                message.json = reader.string();
                break;
            default:
                reader.skipType(tag & 7);
                break;
            }
        }
        if (!message.hasOwnProperty("json"))
            throw $util.ProtocolError("missing required 'json'", { instance: message });
        return message;
    };

    /**
     * Decodes a PreviewData message from the specified reader or buffer, length delimited.
     * @function decodeDelimited
     * @memberof PreviewData
     * @static
     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
     * @returns {PreviewData} PreviewData
     * @throws {Error} If the payload is not a reader or valid buffer
     * @throws {$protobuf.util.ProtocolError} If required fields are missing
     */
    PreviewData.decodeDelimited = function decodeDelimited(reader) {
        if (!(reader instanceof $Reader))
            reader = new $Reader(reader);
        return this.decode(reader, reader.uint32());
    };

    /**
     * Verifies a PreviewData message.
     * @function verify
     * @memberof PreviewData
     * @static
     * @param {Object.<string,*>} message Plain object to verify
     * @returns {string|null} `null` if valid, otherwise the reason why it is not
     */
    PreviewData.verify = function verify(message) {
        if (typeof message !== "object" || message === null)
            return "object expected";
        if (!$util.isString(message.json))
            return "json: string expected";
        return null;
    };

    /**
     * Creates a PreviewData message from a plain object. Also converts values to their respective internal types.
     * @function fromObject
     * @memberof PreviewData
     * @static
     * @param {Object.<string,*>} object Plain object
     * @returns {PreviewData} PreviewData
     */
    PreviewData.fromObject = function fromObject(object) {
        if (object instanceof $root.PreviewData)
            return object;
        var message = new $root.PreviewData();
        if (object.json != null)
            message.json = String(object.json);
        return message;
    };

    /**
     * Creates a plain object from a PreviewData message. Also converts values to other types if specified.
     * @function toObject
     * @memberof PreviewData
     * @static
     * @param {PreviewData} message PreviewData
     * @param {$protobuf.IConversionOptions} [options] Conversion options
     * @returns {Object.<string,*>} Plain object
     */
    PreviewData.toObject = function toObject(message, options) {
        if (!options)
            options = {};
        var object = {};
        if (options.defaults)
            object.json = "";
        if (message.json != null && message.hasOwnProperty("json"))
            object.json = message.json;
        return object;
    };

    /**
     * Converts this PreviewData to JSON.
     * @function toJSON
     * @memberof PreviewData
     * @instance
     * @returns {Object.<string,*>} JSON object
     */
    PreviewData.prototype.toJSON = function toJSON() {
        return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
    };

    return PreviewData;
})();

$root.CanvasData = (function() {

    /**
     * Properties of a CanvasData.
     * @exports ICanvasData
     * @interface ICanvasData
     * @property {string} json CanvasData json
     */

    /**
     * Constructs a new CanvasData.
     * @exports CanvasData
     * @classdesc Represents a CanvasData.
     * @implements ICanvasData
     * @constructor
     * @param {ICanvasData=} [properties] Properties to set
     */
    function CanvasData(properties) {
        if (properties)
            for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                if (properties[keys[i]] != null)
                    this[keys[i]] = properties[keys[i]];
    }

    /**
     * CanvasData json.
     * @member {string} json
     * @memberof CanvasData
     * @instance
     */
    CanvasData.prototype.json = "";

    /**
     * Creates a new CanvasData instance using the specified properties.
     * @function create
     * @memberof CanvasData
     * @static
     * @param {ICanvasData=} [properties] Properties to set
     * @returns {CanvasData} CanvasData instance
     */
    CanvasData.create = function create(properties) {
        return new CanvasData(properties);
    };

    /**
     * Encodes the specified CanvasData message. Does not implicitly {@link CanvasData.verify|verify} messages.
     * @function encode
     * @memberof CanvasData
     * @static
     * @param {ICanvasData} message CanvasData message or plain object to encode
     * @param {$protobuf.Writer} [writer] Writer to encode to
     * @returns {$protobuf.Writer} Writer
     */
    CanvasData.encode = function encode(message, writer) {
        if (!writer)
            writer = $Writer.create();
        writer.uint32(/* id 20, wireType 2 =*/162).string(message.json);
        return writer;
    };

    /**
     * Encodes the specified CanvasData message, length delimited. Does not implicitly {@link CanvasData.verify|verify} messages.
     * @function encodeDelimited
     * @memberof CanvasData
     * @static
     * @param {ICanvasData} message CanvasData message or plain object to encode
     * @param {$protobuf.Writer} [writer] Writer to encode to
     * @returns {$protobuf.Writer} Writer
     */
    CanvasData.encodeDelimited = function encodeDelimited(message, writer) {
        return this.encode(message, writer).ldelim();
    };

    /**
     * Decodes a CanvasData message from the specified reader or buffer.
     * @function decode
     * @memberof CanvasData
     * @static
     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
     * @param {number} [length] Message length if known beforehand
     * @returns {CanvasData} CanvasData
     * @throws {Error} If the payload is not a reader or valid buffer
     * @throws {$protobuf.util.ProtocolError} If required fields are missing
     */
    CanvasData.decode = function decode(reader, length) {
        if (!(reader instanceof $Reader))
            reader = $Reader.create(reader);
        var end = length === undefined ? reader.len : reader.pos + length, message = new $root.CanvasData();
        while (reader.pos < end) {
            var tag = reader.uint32();
            switch (tag >>> 3) {
            case 20:
                message.json = reader.string();
                break;
            default:
                reader.skipType(tag & 7);
                break;
            }
        }
        if (!message.hasOwnProperty("json"))
            throw $util.ProtocolError("missing required 'json'", { instance: message });
        return message;
    };

    /**
     * Decodes a CanvasData message from the specified reader or buffer, length delimited.
     * @function decodeDelimited
     * @memberof CanvasData
     * @static
     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
     * @returns {CanvasData} CanvasData
     * @throws {Error} If the payload is not a reader or valid buffer
     * @throws {$protobuf.util.ProtocolError} If required fields are missing
     */
    CanvasData.decodeDelimited = function decodeDelimited(reader) {
        if (!(reader instanceof $Reader))
            reader = new $Reader(reader);
        return this.decode(reader, reader.uint32());
    };

    /**
     * Verifies a CanvasData message.
     * @function verify
     * @memberof CanvasData
     * @static
     * @param {Object.<string,*>} message Plain object to verify
     * @returns {string|null} `null` if valid, otherwise the reason why it is not
     */
    CanvasData.verify = function verify(message) {
        if (typeof message !== "object" || message === null)
            return "object expected";
        if (!$util.isString(message.json))
            return "json: string expected";
        return null;
    };

    /**
     * Creates a CanvasData message from a plain object. Also converts values to their respective internal types.
     * @function fromObject
     * @memberof CanvasData
     * @static
     * @param {Object.<string,*>} object Plain object
     * @returns {CanvasData} CanvasData
     */
    CanvasData.fromObject = function fromObject(object) {
        if (object instanceof $root.CanvasData)
            return object;
        var message = new $root.CanvasData();
        if (object.json != null)
            message.json = String(object.json);
        return message;
    };

    /**
     * Creates a plain object from a CanvasData message. Also converts values to other types if specified.
     * @function toObject
     * @memberof CanvasData
     * @static
     * @param {CanvasData} message CanvasData
     * @param {$protobuf.IConversionOptions} [options] Conversion options
     * @returns {Object.<string,*>} Plain object
     */
    CanvasData.toObject = function toObject(message, options) {
        if (!options)
            options = {};
        var object = {};
        if (options.defaults)
            object.json = "";
        if (message.json != null && message.hasOwnProperty("json"))
            object.json = message.json;
        return object;
    };

    /**
     * Converts this CanvasData to JSON.
     * @function toJSON
     * @memberof CanvasData
     * @instance
     * @returns {Object.<string,*>} JSON object
     */
    CanvasData.prototype.toJSON = function toJSON() {
        return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
    };

    return CanvasData;
})();

module.exports = $root;
